// *** Dateihandling.C des FileCutter
// *** (c) 1997 by Stefan Berge / PSILON

// *** Include - Files

#include <pragma/intuition_lib.h>
#include <pragma/graphics_lib.h>
#include <pragma/dos_lib.h>
#include <pragma/gadtools_lib.h>
#include <pragma/exec_lib.h>
#include <dos/dostags.h>
#include <string.h>
#include <exec/memory.h>
#include <stdio.h>

// ***  eigene Include - Files

#include "Global.h"
#include "Sonstiges.h"
#include "FileCutter_1.3_C.h"
#include "Dateihandling_C.h"

BOOL Datloeschen(UWORD start, UBYTE *ziel, UBYTE *FCode)
{
	UWORD  b = 0 ;
	UBYTE *pfad = 0 ;

	*FCode = 0 ;

	if(!(pfad = (UBYTE *) AllocVec(strlen(ziel) + 5, MEMF_ANY | MEMF_CLEAR)))
		*FCode = FHILFSVARIABLE ;
	else
	{
		for(b = start; b > 1; b--)
		{
			if(b > 0 && b < 10)
				sprintf(pfad, "%s.00%d", ziel, b) ;
			else
			{
				if(b > 9 && b < 100)
					sprintf(pfad, "%s.0%d", ziel, b) ;
				else
					sprintf(pfad, "%s.%d", ziel, b) ;
			}
			if(DeleteFile(pfad) == DOSFALSE)
				*FCode = FDOS ;
		}
	}
	if(pfad)
		FreeVec(pfad) ;

	if(*FCode == 0)
		return(TRUE) ;
	else
		return(FALSE) ;
}

BOOL DateiZusammensetzen(STRPTR datei, UBYTE *ziel, BOOL loeschen, BOOL nc, UBYTE *FCode)
{
	struct FileHandle		*dat = NULL, *dat2 = NULL ;
	struct FileInfoBlock	*FInfo = NULL ;
	APTR					 datspeicher = NULL, sicherdat = NULL ;
	UBYTE					 kopfgroesse = 0, *bytedat = NULL, *pfad = NULL ;
	UWORD					*worddat = NULL, a = NULL ;
	struct Window			*statuswin = NULL ;
	
	if(ziel)
	{
		if((dat = (struct FileHandle *) Open(ziel, MODE_OLDFILE)))
		{
			if(!(Warnung(screen, "Die existierende Datei ersetzen?", NULL, TRUE)))
				goto ENDEFUNKT ;
			Close((BPTR) dat) ;
		}
		
		if(!(statuswin = OpenWindowTags(NULL, 
			WA_Activate, TRUE,
			WA_CustomScreen, screen,
			WA_Height, y * 2 + 21,
			WA_Width, 300,
			WA_Left, (screen->Width - 300) / 2,
			WA_Top, (screen->Height - y * 2 - 21) / 2,
			WA_Title, "Status",
			TAG_DONE)))
		{
			*FCode = FFENSTER ;
			goto ENDEFUNKT ;
		}

		DrawBevelBox(statuswin->RPort, 14, y + 7, 272, y + 2, 
			GT_VisualInfo, visuelleInformationen,
			TAG_DONE) ;
		DrawBevelBox(statuswin->RPort, 16, y + 8, 268, y, 
			GT_VisualInfo, visuelleInformationen,
			GTBB_Recessed, TRUE,
			TAG_DONE) ;
		
		if(!(dat = (struct FileHandle *) Open(datei, MODE_OLDFILE)))
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}

		if(!(FInfo = (struct FileInfoBlock *) AllocDosObjectTags(DOS_FIB, 
			ADO_FH_Mode, MODE_OLDFILE,
			TAG_DONE)))
		{
			*FCode = FHILFSVARIABLE ;
			goto ENDEFUNKT ;
		}

		if(ExamineFH((BPTR) dat, FInfo) == DOSFALSE)
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}
		
		if(nc == FALSE)
		{
			teilgroesse1 = FInfo->fib_Size ;
		
			if(!(datspeicher = AllocVec(teilgroesse1, MEMF_ANY | MEMF_CLEAR)))
			{
				*FCode = FHILFSVARIABLE ;
				goto ENDEFUNKT ;
			}
			if(Read((BPTR) dat, datspeicher, teilgroesse1) == -1)
			{
				*FCode = FDOS ;
				goto ENDEFUNKT ;
			}
			sicherdat = datspeicher ;
		}
		else
		{
			teilgroesse = FInfo->fib_Size ;
		
			if(!(datspeicher = AllocVec(teilgroesse, MEMF_ANY | MEMF_CLEAR)))
			{
				*FCode = FHILFSVARIABLE ;
				goto ENDEFUNKT ;
			}
			if(Read((BPTR) dat, datspeicher, teilgroesse) == -1)
			{
				*FCode = FDOS ;
				goto ENDEFUNKT ;
			}
		}
		Close((BPTR)dat) ;
		dat = NULL ;
		
		if(nc == FALSE)
		{
			bytedat = (UBYTE *) datspeicher ;
			if(strncmp(bytedat, "PSFC", 4) != 0)
			{
				if(Warnung(screen, "Entweder handelt es sich um eine sehr alte geteielte Datei oder", "es ist keine FileCutter-Datei. Zusammenfgen?", TRUE))
				{
					datspeicher = sicherdat ;
					worddat = (UWORD *) datspeicher ;
					teilanzahl = *worddat++ ;
					datspeicher = (APTR) worddat ;
					kopfgroesse = 2 ;
				}
				else
					goto ENDEFUNKT ; 
			}
			else
			{
				bytedat += 4 ;
				worddat = (UWORD *) bytedat ;
				switch(*worddat)
				{
					case 101:
						worddat++ ;
						teilanzahl = *worddat ;
						bytedat = (UBYTE *) ++worddat ;
						kopfgroesse = 9 + *bytedat ;
						bytedat += *bytedat + 1 ;
						datspeicher = (APTR) bytedat ;
					break ;
				}
			}
		}
		
		if(!(pfad = (UBYTE *) AllocVec(strlen(datei) + 1, MEMF_ANY | MEMF_CLEAR)))
		{
			*FCode = FHILFSVARIABLE ;
			goto ENDEFUNKT ;
		}
		
		if(nc == TRUE)
		{
			for(teilanzahl = 2;; teilanzahl++)
			{
				strcpy(pfad, datei) ;
				for(UBYTE b = strlen(datei); b >= strlen(datei) - 3; b--)
					*(pfad + b) = 0 ;
				 
				 if(teilanzahl > 1 && teilanzahl < 10)
					sprintf(pfad, "%s00%d", pfad, teilanzahl) ;
				else
					if(teilanzahl > 9 && teilanzahl < 100)
						sprintf(pfad, "%s0%d", pfad, teilanzahl) ;
					else
						sprintf(pfad, "%s%d", pfad, teilanzahl) ;
				
				if(!(dat = (struct FileHandle *)Open(pfad, MODE_OLDFILE)))
					break ;
				Close((BPTR) dat) ;
				dat = NULL ;
			}
			teilanzahl-- ;
		}

		RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) / 100), y*2 + 6) ;
		if(!(dat2 = (struct FileHandle *) Open(ziel, MODE_NEWFILE)))
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}

		if(nc == FALSE)
		{
			if(Write((BPTR)dat2, datspeicher, teilgroesse1 - kopfgroesse) == -1)
			{
				*FCode = FDOS ;
				if(DeleteFile(ziel) == DOSFALSE)
					FehlerMeldungen(FDOS) ;
				goto ENDEFUNKT ;
			}
		}
		else
		{
			if(Write((BPTR)dat2, datspeicher, teilgroesse) == -1)
			{
				*FCode = FDOS ;
				if(DeleteFile(ziel) == DOSFALSE)
					FehlerMeldungen(FDOS) ;
				goto ENDEFUNKT ;
			}
		}

		RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * 2 / 100), y*2 + 6) ;

		if(nc == FALSE)
		{
			if(sicherdat)
			{
				datspeicher = sicherdat ;
				sicherdat = NULL ;
			}
			teilgroesse = 0 ;
			FreeVec(datspeicher) ;
			datspeicher = NULL ;
		}
				
		for(a = 2; a <= teilanzahl; a++)
		{
			strcpy(pfad, datei) ;
			for(UBYTE b = strlen(datei); b >= strlen(datei) - 3; b--)
				*(pfad + b) = 0 ;

			if(a > 1 && a < 10)
				sprintf(pfad, "%s00%d", pfad, a) ;
			else
				if(a > 9 && a < 100)
					sprintf(pfad, "%s0%d", pfad, a) ;
				else
					sprintf(pfad, "%s%d", pfad, a) ;

			if(a != teilanzahl)
			{
				if(!(dat = (struct FileHandle *) Open(pfad, MODE_OLDFILE)))
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					a = teilanzahl + 1 ;
					goto ENDEFUNKT ;
				}
				
				if(teilgroesse == 0)
				{
					if(ExamineFH((BPTR) dat, FInfo) == DOSFALSE)
					{
						*FCode = FDOS ;
						goto ENDEFUNKT ;
					}
					teilgroesse = FInfo->fib_Size ;
					
					if(!(datspeicher = AllocVec(teilgroesse, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}
				}
				
				if(Read((BPTR)dat, datspeicher, teilgroesse) == -1)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					a = teilanzahl + 1 ;
					goto ENDEFUNKT ;
				}

				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a-1) / 100), y*2 + 6) ;
				Close((BPTR) dat) ;
				dat = NULL ;
				if(Write((BPTR)dat2, datspeicher, teilgroesse) == -1)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					a = teilanzahl + 1 ;
					goto ENDEFUNKT ;
				}
				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a) / 100), y*2 + 6) ;
			}
			else
			{
				if(!(dat = (struct FileHandle *) Open(pfad, MODE_OLDFILE)))
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					goto ENDEFUNKT ;
				}

				if(ExamineFH((BPTR)dat, FInfo) == DOSFALSE)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					goto ENDEFUNKT ;
				}

				if(Read((BPTR)dat, datspeicher, FInfo->fib_Size) == -1)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					goto ENDEFUNKT ;
				}

				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a-1) / 100), y*2 + 6) ;
				Close((BPTR) dat) ;
				dat = NULL ;
				if(Write((BPTR)dat2, datspeicher, FInfo->fib_Size) == -1)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					goto ENDEFUNKT ;
				}
				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a) / 100), y*2 + 6) ;
			}
		}
	}
	else
		*FCode = FZIEL ;

	ENDEFUNKT:
	if(dat2)		{ Close((BPTR) dat2) ;					dat2 = NULL ; }
	if(statuswin)	{ CloseWindow(statuswin) ;				statuswin = NULL ; }
	if(datspeicher)	{ FreeVec(datspeicher) ;				datspeicher = NULL ; }
	if(FInfo)		{ FreeDosObject(DOS_FIB, (APTR)FInfo) ;	FInfo = NULL ; }
	if(dat)			{ Close((BPTR) dat) ;					dat = NULL ; }

	if(loeschen == TRUE)
	{
		for(a = 1; a <= teilanzahl; a++)
		{
			strcpy(pfad, datei) ;
			for(UBYTE b = strlen(datei); b >= strlen(datei) - 3; b--)
				*(pfad + b) = 0 ;
			
			if(a > 0 && a < 10)
				sprintf(pfad, "%s00%d", pfad, a) ;
			else
				if(a > 9 && a < 100)
					sprintf(pfad, "%s0%d", pfad, a) ;
				else
					sprintf(pfad, "%s%d", pfad, a) ;

			if(DeleteFile(pfad) == DOSFALSE)
				FehlerMeldungen(FDOS) ;
		} 
	}

	if(*FCode != 0)
		return(FALSE) ;
	else
		return(TRUE) ;
}

// *** END OF FILE
