// *** Sonstiges.C des FileCutter
// *** (c) 1997 by Stefan Berge / PSILON

// *** Include - Files

#include <pragma/intuition_lib.h>
#include <libraries/gadtools.h>
#include <string.h>
#include <exec/memory.h>
#include <pragma/exec_lib.h>
#include <pragma/asl_lib.h>
#include <stdio.h>
#include <pragma/dos_lib.h>

// *** eigen Include - Files

#include "Sonstiges.h"
#include "Global.h"
#include "FileCutter_1.3.h"

void FehlerMeldungen(UBYTE FCode)
{
	switch(FCode)
	{
		case FFENSTER:			Warnung(screen, meldungen.ffenster, meldungen.hinweis1, FALSE) ;				break ;
		case FVINFOS:			Warnung(screen, meldungen.fvinfos, meldungen.hinweis1, FALSE) ;				break ;
		case FGADGETSPEICHER:	Warnung(screen, meldungen.fgadgetspeicher, meldungen.hinweis2, FALSE) ;		break ;
		case FNEWGADGET:		Warnung(screen, meldungen.fnewgadget, meldungen.hinweis2, FALSE) ;			break ;
		case FGADGET:			Warnung(screen, meldungen.fgadget, meldungen.hinweis1, FALSE) ;				break ;
		case FHILFSVARIABLE:	Warnung(screen, meldungen.fhilfsvariable, meldungen.hinweis2, FALSE) ;		break ;
		case FFONTGROESSE:		Warnung(screen, meldungen.ffontgroesse1, meldungen.ffontgroesse2, FALSE) ;	break ;
		case FFILEREQUESTER:	Warnung(screen, meldungen.ffilerequester, meldungen.hinweis1, FALSE) ;		break ;
		case FDOS:				DOS_Fehler() ;																break ;
		case FZIEL:				Warnung(screen, meldungen.fziel, NULL, FALSE) ;								break ;
		case FDATEIGROESSE:		Warnung(screen, meldungen.fdatgr1, meldungen.fdatgr2, FALSE) ;				break ;
	}
}

BOOL Warnung(struct Screen *BS, char *wtext1, char *wtext2, BOOL nein)
{
	struct IntuiText Alarm2 = {1, 0, JAM1, 20, BS->Font->ta_YSize * 2 + 18, BS->Font, wtext2, NULL} ;
	struct IntuiText Alarm1 = {1, 0, JAM1, 20, BS->Font->ta_YSize + 9, BS->Font, wtext1, &Alarm2} ;
	struct IntuiText ja = {NULL}, falsch = {NULL} ;
	if(nein == FALSE)
	{
		falsch.FrontPen		= 1 ;
		falsch.BackPen		= 0 ;
		falsch.DrawMode		= JAM1 ;
		falsch.LeftEdge		= 0 ;
		falsch.TopEdge		= 0 ;
		falsch.ITextFont	= BS->Font ;
		falsch.IText		= "OK" ;
		falsch.NextText		= NULL ;
		return(AutoRequest(BS->FirstWindow, &Alarm1, NULL, &falsch, NULL, NULL, 640, 256)) ;
	}
	else
	{
		ja.FrontPen			= 1 ;
		ja.BackPen			= 0 ;
		ja.DrawMode			= JAM1 ;
		ja.LeftEdge			= 0 ;
		ja.TopEdge			= 0 ;
		ja.ITextFont		= BS->Font ;
		ja.IText			= "Ja" ;
		ja.NextText			= NULL ;
 		falsch.FrontPen		= 1 ;
		falsch.BackPen		= 0 ;
		falsch.DrawMode		= JAM1 ;
		falsch.LeftEdge		= 0 ;
		falsch.TopEdge		= 0 ;
		falsch.ITextFont	= BS->Font ;
		falsch.IText		= "Nein" ;
		falsch.NextText		= NULL ;
		return(AutoRequest(BS->FirstWindow, &Alarm1, &ja, &falsch, NULL, NULL, 640, 256)) ;
	}
}

struct NewGadget *NeuesGadget(struct NewGadget *neuesgadget, WORD x, WORD y, WORD b, WORD h, UBYTE *text,
                              UWORD id, struct TextAttr *BSch)
{
	if(!visuelleInformationen)
		return(NULL) ;
	neuesgadget->ng_LeftEdge	= x ;
	neuesgadget->ng_TopEdge		= y ;
	neuesgadget->ng_Width		= b ;
	neuesgadget->ng_Height		= h ;
	neuesgadget->ng_GadgetText	= text ;
	neuesgadget->ng_TextAttr	= BSch ;
	neuesgadget->ng_GadgetID	= id ;
	neuesgadget->ng_Flags		= NG_HIGHLABEL ;
	neuesgadget->ng_VisualInfo	= visuelleInformationen ;
	return(neuesgadget) ;
}

UBYTE *DateiREQ(UBYTE *zeichenfolge, UBYTE *FCode, struct Window *win, BOOL drawers)
{
	struct FileRequester *Dateireq = NULL ;
	UWORD                 a = 0, b = 0, laenge = strlen(zeichenfolge) ;
	UBYTE                *pfad = zeichenfolge, *pfad2 = NULL ;

	*FCode = 0 ;

	for(a = 0; a < laenge; a++)
		pfad++ ;

	for(a = laenge; a > 0 && *pfad != '/' && *pfad != ':'; a--)
		pfad-- ;

	if(*pfad == ':')
		a = a + 1 ;
	else
		b = a ;

	pfad = NULL ;
	if(!(pfad = (UBYTE *)AllocVec(b+1, MEMF_ANY | MEMF_CLEAR)))
		*FCode = FHILFSVARIABLE ;
	else
	{
		strncpy(pfad, zeichenfolge, b) ;
		if(!(Dateireq = (struct FileRequester *)AllocAslRequest(0, TAG_DONE)))
			*FCode = FFILEREQUESTER ;
		else
		{
			if(AslRequestTags(Dateireq, 
				ASLFR_SleepWindow, TRUE,
				ASLFR_Window, win,
				ASLFR_TextAttr, win->WScreen->Font,
				ASLFR_TitleText, "Bitte whle...",
				ASLFR_InitialDrawer, pfad,
				ASLFR_InitialHeight, 200,
				ASLFR_InitialWidth, 400,
				ASLFR_InitialLeftEdge, (((win->WScreen->Width)-400)/2),
				ASLFR_InitialTopEdge, (((win->WScreen->Height)-200)/2),
				ASLFR_DrawersOnly, drawers,
				ASLFR_RejectIcons, TRUE,
				TAG_DONE) != 0)
			{
				if(strlen(Dateireq->fr_File) != 0)
				{
					if(strlen(Dateireq->fr_Drawer)-1 == strcspn(Dateireq->fr_Drawer, ":") || strlen(Dateireq->fr_Drawer)-1 == strcspn(Dateireq->fr_Drawer, "/"))
					{
						if(zeichenfolge)
							FreeVec(zeichenfolge) ;
						if(!(zeichenfolge = (UBYTE *) AllocVec(strlen(Dateireq->fr_Drawer) + strlen(Dateireq->fr_File) + 1, MEMF_ANY | MEMF_CLEAR)))
						{
							*FCode = FHILFSVARIABLE ;
							zeichenfolge = NULL ;
						}
						else
							sprintf(zeichenfolge, "%s%s", Dateireq->fr_Drawer, Dateireq->fr_File) ;
					}
					else
					{
						if(zeichenfolge)
							FreeVec(zeichenfolge) ;
						if(!(zeichenfolge = (UBYTE *) AllocVec(strlen(Dateireq->fr_Drawer) + strlen(Dateireq->fr_File) + 2, MEMF_ANY | MEMF_CLEAR)))
						{
							*FCode = FHILFSVARIABLE ;
							zeichenfolge = NULL ;
						}
						else
							sprintf(zeichenfolge, "%s/%s",Dateireq->fr_Drawer, Dateireq->fr_File) ;
					}
				}
				else
				{
					if(zeichenfolge)
					{
						FreeVec(zeichenfolge) ;
						zeichenfolge = NULL ;
					}
					if(drawers == TRUE || strlen(Dateireq->fr_Drawer) != 0)
					{
						if(!(zeichenfolge = (UBYTE *) AllocVec(strlen(Dateireq->fr_Drawer) + 2, MEMF_ANY | MEMF_CLEAR)))
						{
							*FCode = FHILFSVARIABLE ;
							zeichenfolge = NULL ;
						}
						else
						{
							if(strlen(Dateireq->fr_Drawer)-1 == strcspn(Dateireq->fr_Drawer, ":"))
								sprintf(zeichenfolge, "%s", Dateireq->fr_Drawer) ;
							else
								sprintf(zeichenfolge, "%s/", Dateireq->fr_Drawer) ;
						}
					}
				}
			}
		}
		if(Dateireq)
			FreeAslRequest(Dateireq) ;
	}
	if(pfad)
		FreeVec(pfad) ;

	if(*zeichenfolge == '/')
	{
		if(!(pfad = (UBYTE *) AllocVec(256, MEMF_ANY | MEMF_CLEAR)))
			*FCode = FHILFSVARIABLE ;
		else
		{
			if(GetCurrentDirName(pfad, 256) == DOSFALSE)
				*FCode = FDOS ;
			else
			{
				if(!(pfad2 = (UBYTE *) AllocVec(strlen(pfad) + strlen(zeichenfolge) + 1, MEMF_ANY | MEMF_CLEAR)))
					*FCode = FHILFSVARIABLE ;
				else
				{
					strcpy(pfad2, pfad) ;
					strcat(pfad2, zeichenfolge) ;
					FreeVec(zeichenfolge) ;
					zeichenfolge = pfad2 ;
				}
			}
		}
		if(pfad) { FreeVec(pfad) ; }
	}

	if(*FCode == 0)
		return(zeichenfolge) ;
	else
		return(NULL) ;
}

UBYTE *E_Stringgad(UBYTE *SVar, struct Gadget *sgad, UBYTE *FCode)
{
	if(SVar)
		FreeVec(SVar) ;
	if(strlen(((struct StringInfo *) sgad->SpecialInfo)->Buffer) != 0)
	{
		if(!(SVar = (UBYTE *) AllocVec(strlen(((struct StringInfo *)sgad->SpecialInfo)->Buffer) + 1, MEMF_ANY | MEMF_CLEAR)))
		{
			*FCode = FHILFSVARIABLE ;
			SVar = NULL ;
		}
		else
		{
			strcpy(SVar, ((struct StringInfo *)sgad->SpecialInfo)->Buffer) ;
			return(SVar) ;
		}
	}
	return(NULL) ;
}

// *** END OF FILE
